package quimufu.colourful_portals.mixin;

import net.minecraft.block.BlockState;
import net.minecraft.registry.Registries;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import static quimufu.colourful_portals.ColourfulPortalsMod.*;

@Mixin(ServerWorld.class)
public class BlockChangeMixin {

    @Inject(at = @At("RETURN"), method = "onBlockChanged")
    private void cpm_afterOnBlockChanged(BlockPos pos, BlockState oldBlock, BlockState newBlock, CallbackInfo info) {
        ServerWorld world = (ServerWorld) (Object) this;
        if(world.isDebugWorld()|| !world.isChunkLoaded(pos))
            return;
        // This code is injected into the end of ServerWorld.onBlockChanged()V
        if (oldBlock.getBlock() != newBlock.getBlock()) {
            if (PORTAL_BLOCKS.contains(Registries.BLOCK.getId(newBlock.getBlock()))) {
                LOGGER.info("onBlockNew {} -> {}", oldBlock, newBlock);
                Identifier blockId = Registries.BLOCK.getId(newBlock.getBlock());
                PORTAL_MANAGER.onPortalBlockPlaced(world, pos, blockId);

            }
            if (PORTAL_BLOCKS.contains(Registries.BLOCK.getId(oldBlock.getBlock()))) {
                LOGGER.info("onBlockOld {} -> {}", oldBlock, newBlock);
                Identifier blockId = Registries.BLOCK.getId(oldBlock.getBlock());
                PORTAL_MANAGER.onPortalBlockBroken(world, pos, blockId);
            }
        }

    }
}